#!/usr/bin/perl -w

## undef = hello($name)
##  + subroutine to greet $name abstractly
sub hello {
  my $name = shift(@_);        # get our first and only argument
  print "Hello, $name!\n";     # ... and greet 'em
}

## undef = do_something(@what)
##   + sets global $name to $what[0]
sub do_something {
  print "(doing something: ", @_, ")\n";
  $name = $_[0];              # side effect: set $name
}


# ... meet some folks, assign the variable $name ...
do_something('whatever');
hello($name);                 # greet someone


# ... meet some other folks, re-assign $name
do_something('else');
hello($name);                 # greet someone else
