#!/usr/bin/perl -w

@folks = ('moocow', 'Bryan');        # literal list

print 'Who is here? ';               # no interpolation
while (defined($name = <STDIN>)) {
  chomp($name);
  push (@folks, $name);              # add name to array
  print 'Who else is here? ';
}
print "\n";

foreach $name (sort(@folks)) {       # alphabetical sort
  print ("Hello, ", $name, "!\n");   # print a list
}
